﻿'Programed by NAS6

'複素数
Public Class Complex
    Implements IComparable
    Implements ICloneable

    Public c As New Vector(2)


    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New Complex
        ret.c = Me.c.Clone()
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Complex = Me
        Dim rh As Complex = obj
        Dim i As Integer
        For i = 0 To 1
            If Not lh.c.x(i) = rh.c.x(i) Then
                CompareTo = CompareTo Or (1 << i)
            End If
        Next
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Complex, ByVal rh As Complex) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Complex, ByVal rh As Complex) As Boolean
        Return (Not lh = rh)
    End Operator


    'コンストラクタ
    Public Sub New()
        Dim i As Integer
        For i = 0 To 1
            c.x(i) = 0.0
        Next
    End Sub

    'コンストラクタ
    Public Sub New(ByVal x As Double, ByVal y As Double)
        c.x(0) = x
        c.x(1) = y
    End Sub

    '四則演算
    Public Shared Operator +(ByVal lh As Complex, ByVal rh As Complex) As Complex
        Dim CmpWK As New Complex
        CmpWK.c = lh.c + rh.c
        Return CmpWK
    End Operator

    Public Shared Operator -(ByVal lh As Complex, ByVal rh As Complex) As Complex
        Dim CmpWK As New Complex
        CmpWK.c = lh.c - rh.c
        Return CmpWK
    End Operator

    Public Shared Operator *(ByVal lh As Complex, ByVal rh As Complex) As Complex
        Dim CmpWK As New Complex
        CmpWK.c.x(0) = lh.c.x(0) * rh.c.x(0) - lh.c.x(1) * rh.c.x(1)
        CmpWK.c.x(1) = lh.c.x(0) * rh.c.x(1) + lh.c.x(1) * rh.c.x(0)
        Return CmpWK
    End Operator

    Public Shared Operator /(ByVal lh As Complex, ByVal rh As Complex) As Complex
        Dim CmpWK As New Complex
        Dim dblDIV As Double
        If (rh.c.x(0) = 0) And (rh.c.x(1) = 0) Then
            CmpWK.c = CmpWK.c.ZeroVec()
        Else
            dblDIV = (rh.c.x(0) * rh.c.x(0)) + (rh.c.x(1) * rh.c.x(1))
            CmpWK.c.x(0) = ((lh.c.x(0) * rh.c.x(0)) + (lh.c.x(1) * rh.c.x(1))) / dblDIV
            CmpWK.c.x(1) = ((lh.c.x(1) * rh.c.x(0)) - (lh.c.x(0) * rh.c.x(1))) / dblDIV
        End If
        Return CmpWK
    End Operator

    '絶対値2乗
    Public Function SquareAbs() As Double
        Dim DblWK As New Double
        DblWK = ((Me.c.x(0) * Me.c.x(0)) + (Me.c.x(1) * Me.c.x(1)))
        Return DblWK
    End Function

    '絶対値
    Public Function Abs() As Double
        Dim DblWK As Double = 0.0
        DblWK = Math.Sqrt(Me.SquareAbs())
        Return DblWK
    End Function

    '共役
    Public Function Conjugation() As Complex
        Dim CmpWK As New Complex
        CmpWK.c.x(0) = Me.c.x(0)
        CmpWK.c.x(1) = Me.c.x(1) * (-1)
        Return CmpWK
    End Function

End Class
