﻿'Programed by NAS6


Public Class Form1
    Public r3d As Render3D
    Public Poly1 As Polygon
    Public Camera As New Local

    Public MC As MouseCamera

    Public Const YR As Double = 0.1
    Public Const PR As Double = 0.1
    Public Const RR As Double = 0.1
    Public Const ZR As Double = 4.0


    Private Sub PictureBox_MouseDown(sender As Object, e As MouseEventArgs) Handles PictureBox.MouseDown
        MC.MouseDown(sender, e)
    End Sub

    Private Sub PictureBox_MouseMove(sender As Object, e As MouseEventArgs) Handles PictureBox.MouseMove
        MC.MouseMove(sender, e)
    End Sub

    Private Sub PictureBox_MouseUp(sender As Object, e As MouseEventArgs) Handles PictureBox.MouseUp
        MC.MouseUp(sender, e)
    End Sub

    Private Sub SetRate(ByVal i As Integer, ByVal b As Boolean)
        Dim m As New Matrix(4)
        If b Then
            Dim dt As Double
            Dim j As Integer
            Dim s As Sphere = r3d.Sphr.buf(i)
            'm = r3d.CameraMat.Clone()
            m = m.UnitMat()
            For j = 0 To r3d.Camera.lcl.Count - 1
                m *= r3d.Camera.lcl.buf(j)
            Next
            m *= r3d.CameraMat
            m = m.InverseMat(dt)
            For j = 0 To s.local.lcl.Count - 1
                m *= s.local.lcl.buf(j)
            Next
        Else
            Dim dt As Double
            Dim j As Integer
            Dim p As Polygon = r3d.Poly.buf(i)
            'm = r3d.CameraMat.Clone()
            m = m.UnitMat()
            For j = 0 To r3d.Camera.lcl.Count - 1
                m *= r3d.Camera.lcl.buf(j)
            Next
            m *= r3d.CameraMat
            m = m.InverseMat(dt)
            For j = 0 To p.local.lcl.Count - 1
                m *= p.local.lcl.buf(j)
            Next
        End If
        Dim v As New Vector(4, True)
        v = v.ZeroVec()
        v = m * v
        Dim d As Double = v.Abs()
        MC.YawRate = YR / (d / 4.0)
        MC.PitchRate = PR / (d / 4.0)
        MC.RollRate = RR / (d / 4.0)
        MC.ZoomRate = ZR / (d / 4.0)
    End Sub
    '立方体設定
    Private Sub SetCube(ByRef p() As Triangle, ByVal vcol As System.Drawing.Color, ByVal tcol As System.Drawing.Color, ByVal r As Double, ByVal mtr As Material)
        Dim i As Integer
        Dim j As Integer = 7
        Dim k As Integer
        Dim pv(j) As Vector
        For i = 0 To j
            pv(i) = New Vector(4, True)
        Next

        pv(0).x(1) = r
        pv(0).x(2) = r
        pv(0).x(3) = r

        pv(1).x(1) = r
        pv(1).x(2) = r
        pv(1).x(3) = -r

        pv(2).x(1) = r
        pv(2).x(2) = -r
        pv(2).x(3) = r

        pv(3).x(1) = r
        pv(3).x(2) = -r
        pv(3).x(3) = -r

        pv(4).x(1) = -r
        pv(4).x(2) = r
        pv(4).x(3) = r

        pv(5).x(1) = -r
        pv(5).x(2) = r
        pv(5).x(3) = -r

        pv(6).x(1) = -r
        pv(6).x(2) = -r
        pv(6).x(3) = r

        pv(7).x(1) = -r
        pv(7).x(2) = -r
        pv(7).x(3) = -r

        k = 11
        ReDim p(k)
        For i = 0 To k
            p(i) = New Triangle()
            For j = 0 To 2
                p(i).v(j) = New Vector(4, True)
            Next
            'ポリゴン(ワイヤーフレームの場合コメントアウト)
            p(i).vcol = vcol
            p(i).tcol = tcol
            p(i).mtr = mtr.Clone()
        Next

        p(0).v(0) = pv(0)
        p(0).v(1) = pv(3)
        p(0).v(2) = pv(1)

        p(1).v(0) = pv(0)
        p(1).v(1) = pv(2)
        p(1).v(2) = pv(3)

        p(2).v(0) = pv(0)
        p(2).v(1) = pv(5)
        p(2).v(2) = pv(4)

        p(3).v(0) = pv(0)
        p(3).v(1) = pv(1)
        p(3).v(2) = pv(5)

        p(4).v(0) = pv(4)
        p(4).v(1) = pv(2)
        p(4).v(2) = pv(0)

        p(5).v(0) = pv(4)
        p(5).v(1) = pv(6)
        p(5).v(2) = pv(2)

        p(6).v(0) = pv(5)
        p(6).v(1) = pv(6)
        p(6).v(2) = pv(4)

        p(7).v(0) = pv(5)
        p(7).v(1) = pv(7)
        p(7).v(2) = pv(6)

        p(8).v(0) = pv(3)
        p(8).v(1) = pv(6)
        p(8).v(2) = pv(7)

        p(9).v(0) = pv(3)
        p(9).v(1) = pv(2)
        p(9).v(2) = pv(6)

        p(10).v(0) = pv(1)
        p(10).v(1) = pv(7)
        p(10).v(2) = pv(5)

        p(11).v(0) = pv(1)
        p(11).v(1) = pv(3)
        p(11).v(2) = pv(7)
    End Sub


    Private Sub DragLine(ByVal gPic As System.Drawing.Graphics)
        If MC.bd Then
            Dim p0 As New Point(PictureBox.Width / 2, PictureBox.Height / 2)
            gPic.DrawLine(Pens.Blue, p0.X, p0.Y, MC.bm.X, MC.bm.Y)
        End If
    End Sub

    Private Sub Application_ApplicationExit(ByVal sender As Object, ByVal e As EventArgs)

        'ApplicationExitイベントハンドラを削除
        RemoveHandler Application.ApplicationExit, AddressOf Application_ApplicationExit
    End Sub

    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        'ApplicationExitイベントハンドラを追加
        AddHandler Application.ApplicationExit, AddressOf Application_ApplicationExit

        Dim LocalMat As New Matrix(4)
        LocalMat = LocalMat.UnitMat()
        MC = New MouseCamera(LocalMat, PictureBox.Width, PictureBox.Height, YR, PR, RR, ZR)


        '検証テスト
        Init(True)
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
        '検証テスト
        UpdateFrame()
    End Sub


    Private Sub Init(ByVal sw As Boolean)
        Dim canvas As New Bitmap(PictureBox.Width, PictureBox.Height)
        Dim gPic As Graphics = Graphics.FromImage(canvas)


        Dim rnd As New MyRandom
        Dim dat(100000) As Double
        Dim dat2(50000) As Integer
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        For i = 0 To 100000
            dat(i) = Rnd.DoubleXORSRandom()
        Next

        k = 0
        For i = 0 To 100000 - 1
            For j = i + 1 To 100000
                If dat(i) = dat(j) Then
                    dat2(k * 2 + 0) = i
                    dat2(k * 2 + 1) = j
                    k += 1
                End If
            Next
        Next




        Dim FileName As String = "RandomNumber.txt"
        Dim Writer As IO.StreamWriter
        Dim Encode As System.Text.Encoding
        Encode = System.Text.Encoding.GetEncoding("Shift-JIS")

        Writer = New IO.StreamWriter(FileName, False, Encode)

        For i = 0 To 100000
            Writer.WriteLine(dat(i))
        Next
        Writer.WriteLine()
        For i = 0 To k
            Writer.WriteLine(String.Format("{0} , {1}", dat2(i * 2 + 0), dat2(i * 2 + 1)))
        Next

        Writer.Close()


        Dim str As String = ""
        str = str + "Programed by NAS6" + vbCrLf
        str = str + String.Format("重複= {0}", k) + vbCrLf
        TextBox.Text = str

        Dim LocalMat As New Matrix(4)
        Dim Loc1 As New Local
        Dim LocL As New Local
        Dim Cam As New Local


        LocalMat = LocalMat.UnitMat()
        LocalMat.x(3).x(0) = -12.0
        Cam.lcl.Enqueue(LocalMat)

        Dim mtr1 As New Material(0.25, 0.8)
        Dim p1(0) As Triangle
        SetCube(p1, Color.Blue, Color.Cyan, 1.0, mtr1)

        '物体回転のみ
        LocalMat = LocalMat.UnitMat()
        LocalMat.x(3).x(0) = 4.0
        Loc1.lcl.Enqueue(LocalMat)


        Poly1 = New Polygon(Loc1, p1, 1.0, 8.0)



        '点光源を動かす
        LocalMat = LocalMat.UnitMat()
        LocalMat.x(3).x(0) = 4.0
        LocL.lcl.Enqueue(LocalMat)
        LocalMat = LocalMat.UnitMat()
        LocalMat.x(3).x(0) = 3.0
        LocL.lcl.Enqueue(LocalMat)
        LocalMat = LocalMat.UnitMat()
        LocL.lcl.Enqueue(LocalMat)

        Dim vp As New Vector(4, True)
        vp.x(0) = 1.0
        vp.x(1) = 4.0
        vp.x(2) = 2.0
        vp.x(3) = 0.0
        Dim kk(2) As Double
        kk(0) = 0.0
        kk(1) = 0.0
        kk(2) = 0.1
        Dim vd As New Vector(4, True)
        vd.x(0) = 1.0
        vd.x(1) = 1.0
        vd.x(2) = -1.0
        vd.x(3) = 1.0
        'Dim lgt As New Light(Color.White, Color.Black, LocL, kk, Color.Black, vd, True)
        'Dim lgt As New Light(Color.Black, Color.White, LocL, kk, Color.Black, vd, True)
        'Dim lgt As New Light(Color.Black, Color.Black, LocL, kk, Color.White, vd, True)
        'Dim lgt As New Light(Color.FromArgb(255, 32, 32, 32), Color.White, LocL, kk, Color.Black, vd, True)
        Dim lgt As New Light(Color.FromArgb(255, 32, 32, 32), Color.White, LocL, kk, Color.FromArgb(255, 64, 64, 64), vd, True)

        Dim pol As New MyQueue(Of Polygon)
        pol.Enqueue(Poly1)

        r3d = New Render3D(Cam, pol, 1.0, 8.0, lgt)
        'r3d = New Render3D(Cam,pol, lgt)
        'r3d = New Render3D(Cam, pol, New Frustum(4.0, 100.0, -0.5, 0.5, -0.5, 0.5), lgt)

        'r3d.Render(gPic,canvas, 300, 300, 180, 180, False)
        r3d.Render(gPic, canvas, 300, 300, 180, 180, True)


        gPic.Dispose()
        PictureBox.Image = canvas
        Timer1.Start()
    End Sub

    Private Sub UpdateFrame()
        Dim canvas As New Bitmap(PictureBox.Width, PictureBox.Height)
        Dim gPic As Graphics = Graphics.FromImage(canvas)
        Dim LocalMat As New Matrix(4)
        Dim ax As New Vector(4, True)
        ax = ax.UnitVec(1)
        Dim ay As New Vector(4, True)
        ay = ay.UnitVec(2)

        Dim q As New Quaternion()

        '物体回転のみ
        LocalMat = r3d.Poly.buf(0).Local.lcl.buf(0).Clone()
        LocalMat *= q.RotAxis(ay, Math.PI / 180.0).Rot()
        LocalMat *= q.RotAxis(ax, Math.PI / 2.0 / 180.0).Rot()
        r3d.Poly.buf(0).Local.lcl.buf(0) = LocalMat.Clone()


        '点光源を動かす
        LocalMat = r3d.lgt.px.lcl.buf(0).Clone()
        LocalMat *= q.RotAxis(ax, Math.PI * 10.0 / 180.0).Rot()
        LocalMat *= q.RotAxis(ay, Math.PI * 10.0 / 180.0).Rot()
        r3d.lgt.px.lcl.buf(0) = LocalMat.Clone()


        MC.UpdateFrame3()
        r3d.CameraMat = MC.m.Clone()


        'r3d.Render(gPic,canvas, 300, 300, 180, 180, False)
        r3d.Render(gPic, canvas, 300, 300, 180, 180, True)

        DragLine(gPic)
        'SetRate(ni, nb)


        gPic.Dispose()
        PictureBox.Image = canvas

    End Sub
End Class














