﻿'Programed by NAS6


Public Class MouseCamera
    Implements ICloneable

    Public m As Matrix                  'カメラ行列
    Public YawRate As Double = 1.0      'ヨー倍率
    Public PitchRate As Double = 1.0    'ピッチ倍率
    Public RollRate As Double = 1.0     'ロール倍率
    Public ZoomRate As Double = 1.0     'ズーム倍率
    Public Width As Integer = 0         '幅
    Public Height As Integer = 0        '高さ
    Public Accel As Double = 0.0        'アクセル

    Public bd As Boolean                'ドラッグフラグ
    Public bm As MouseEventArgs         'マウス座標バンク

    Public Sub New()
        m = New Matrix(4)
        bd = False
        bm = New MouseEventArgs(MouseButtons.None, 0, 0, 0, 0)
    End Sub

    Public Sub New(ByVal pm As Matrix, ByVal w As Integer, ByVal h As Integer)
        m = pm.Clone()
        Width = w
        Height = h
        bd = False
        bm = New MouseEventArgs(MouseButtons.None, 0, 0, 0, 0)
    End Sub

    Public Sub New(ByVal pm As Matrix, ByVal w As Integer, ByVal h As Integer, ByVal y As Double, ByVal p As Double, ByVal r As Double, ByVal z As Double)
        m = pm.Clone()
        Width = w
        Height = h
        YawRate = y
        PitchRate = p
        RollRate = r
        ZoomRate = z
        bd = False
        bm = New MouseEventArgs(MouseButtons.None, 0, 0, 0, 0)
    End Sub

    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New MouseCamera
        ret.m = Me.m.Clone()
        ret.YawRate = Me.YawRate
        ret.PitchRate = Me.PitchRate
        ret.RollRate = Me.RollRate
        ret.ZoomRate = Me.ZoomRate
        ret.Width = Me.Width
        ret.Height = Me.Height
        ret.bd = Me.bd
        ret.bm = Me.bm
        Return ret
    End Function

    Public Sub MouseDown(sender As Object, e As MouseEventArgs)
        If e.Button = MouseButtons.Left Or e.Button = MouseButtons.Right Or e.Button = MouseButtons.Middle Then
            bd = True
            bm = e
        End If
    End Sub

    Public Sub MouseMove(sender As Object, e As MouseEventArgs)
        If bd Then
            bm = e
            'If bm.Button = MouseButtons.Left Then
            'Roll(bm)
            'ElseIf bm.Button = MouseButtons.Right Then
            'Zoom(bm)
            'ElseIf bm.Button = MouseButtons.Middle Then
            'Translate(bm)
            'End If
        End If
    End Sub

    Public Sub MouseUp(sender As Object, e As MouseEventArgs)
        If e.Button = MouseButtons.Left Or e.Button = MouseButtons.Right Or e.Button = MouseButtons.Middle Then
            bd = False
        End If
    End Sub

    Public Sub UpdateFrame()
        If bd Then
            If bm.Button = MouseButtons.Left Then
                YawAndPitch(bm)
            ElseIf bm.Button = MouseButtons.Right Then
                RollAndAccel(bm)
            ElseIf bm.Button = MouseButtons.Middle Then
                Translate(bm)
            End If
        End If
        Dim y As Double = Accel * ZoomRate
        Dim vv As New Vector(4, True)
        vv = vv.ZeroVec()
        vv.x(3) = y
        Dim mm As Matrix = m.Clone()
        mm.x(1).x(0) = 0.0
        mm.x(2).x(0) = 0.0
        mm.x(3).x(0) = 0.0
        vv = mm * vv
        m.x(1).x(0) += vv.x(1)
        m.x(2).x(0) += vv.x(2)
        m.x(3).x(0) += vv.x(3)
    End Sub

    Public Sub UpdateFrame2(ByRef cmr As Local, ByVal a As Integer, ByVal min As Double)
        If bd Then
            If bm.Button = MouseButtons.Left Then
                YawAndPitch2(bm, cmr, a)
            ElseIf bm.Button = MouseButtons.Right Then
                RollAndZoom2(bm, cmr, a + 1, min)
            ElseIf bm.Button = MouseButtons.Middle Then
                Translate2(bm, cmr, a)
            End If
        End If
    End Sub

    Public Sub UpdateFrame3()
        If bd Then
            If bm.Button = MouseButtons.Left Then
                YawAndPitch3(bm)
            ElseIf bm.Button = MouseButtons.Right Then
                RollAndZoom3(bm)
            ElseIf bm.Button = MouseButtons.Middle Then
                Translate3(bm)
            End If
        End If
    End Sub

    'ヨー＆ピッチ
    Public Sub YawAndPitch(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * YawRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Dim y As Double = v.x(1) / Height * Math.PI * PitchRate
        If Math.PI < y Then
            y = Math.PI
        ElseIf y < -Math.PI Then
            y = -Math.PI
        End If
        Dim ax As New Vector(4, True)
        ax = ax.UnitVec(1)
        Dim ay As New Vector(4, True)
        ay = ay.UnitVec(2)
        m *= m.RotAxisMat(ay, x)
        m *= m.RotAxisMat(ax, y)
    End Sub

    'ロール＆アクセル
    Public Sub RollAndAccel(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * RollRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Accel = v.x(1) / Height
        Dim az As New Vector(4, True)
        az = az.UnitVec(3)
        m *= m.RotAxisMat(az, x)
    End Sub

    '平行移動
    Public Sub Translate(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, -e.Location.Y + Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * ZoomRate
        Dim y As Double = v.x(1) / Height * ZoomRate
        Dim vv As New Vector(4, True)
        vv = vv.ZeroVec()
        vv.x(1) = x
        vv.x(2) = y
        Dim mm As Matrix = m.Clone()
        mm.x(1).x(0) = 0.0
        mm.x(2).x(0) = 0.0
        mm.x(3).x(0) = 0.0
        vv = mm * vv
        m.x(1).x(0) += vv.x(1)
        m.x(2).x(0) += vv.x(2)
        m.x(3).x(0) += vv.x(3)
    End Sub

    'ヨー＆ピッチ
    Public Sub YawAndPitch2(e As MouseEventArgs, ByRef cmr As Local, ByVal a As Integer)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * YawRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Dim y As Double = v.x(1) / Height * Math.PI * PitchRate
        If Math.PI < y Then
            y = Math.PI
        ElseIf y < -Math.PI Then
            y = -Math.PI
        End If
        Dim ax As New Vector(4, True)
        ax = ax.UnitVec(1)
        Dim ay As New Vector(4, True)
        ay = ay.UnitVec(2)


        cmr.lcl.buf(a) *= m.RotAxisMat(ay, -x)
        cmr.lcl.buf(a) *= m.RotAxisMat(ax, -y)
    End Sub

    'ロール＆ズーム
    Public Sub RollAndZoom2(e As MouseEventArgs, ByRef cmr As Local, ByVal a As Integer, ByVal min As Double)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * RollRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Dim y As Double = v.x(1) / Height * ZoomRate
        Dim az As New Vector(4, True)
        az = az.UnitVec(3)
        cmr.lcl.buf(a - 1) *= m.RotAxisMat(az, -x)
        cmr.lcl.buf(a).x(3).x(0) += y
        If -min < cmr.lcl.buf(a).x(3).x(0) Then
            cmr.lcl.buf(a).x(3).x(0) = -min
        End If
    End Sub

    '平行移動
    Public Sub Translate2(e As MouseEventArgs, ByRef cmr As Local, ByVal a As Integer)
    End Sub

    'ヨー＆ピッチ
    Public Sub YawAndPitch3(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * YawRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Dim y As Double = v.x(1) / Height * Math.PI * PitchRate
        If Math.PI < y Then
            y = Math.PI
        ElseIf y < -Math.PI Then
            y = -Math.PI
        End If
        Dim ax As New Vector(4, True)
        ax = ax.UnitVec(1)
        Dim ay As New Vector(4, True)
        ay = ay.UnitVec(2)
        m *= m.RotAxisMat(ay, x)
        m *= m.RotAxisMat(ax, y)
    End Sub

    'ロール＆ズーム
    Public Sub RollAndZoom3(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, e.Location.Y - Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * Math.PI * RollRate
        If Math.PI < x Then
            x = Math.PI
        ElseIf x < -Math.PI Then
            x = -Math.PI
        End If
        Dim y As Double = v.x(1) / Height * ZoomRate
        Dim vv As New Vector(4, True)
        vv = vv.ZeroVec()
        vv.x(3) = y
        Dim mm As Matrix = m.Clone()
        mm.x(1).x(0) = 0.0
        mm.x(2).x(0) = 0.0
        mm.x(3).x(0) = 0.0
        vv = mm * vv
        Dim az As New Vector(4, True)
        az = az.UnitVec(3)
        m *= m.RotAxisMat(az, x)
        m.x(1).x(0) += vv.x(1)
        m.x(2).x(0) += vv.x(2)
        m.x(3).x(0) += vv.x(3)
    End Sub

    '平行移動
    Public Sub Translate3(e As MouseEventArgs)
        Dim dp As New Point(e.Location.X - Width / 2, -e.Location.Y + Height / 2)
        Dim v As New Vector(2)
        v.x(0) = dp.X
        v.x(1) = dp.Y
        Dim x As Double = v.x(0) / Width * ZoomRate
        Dim y As Double = v.x(1) / Height * ZoomRate
        Dim vv As New Vector(4, True)
        vv = vv.ZeroVec()
        vv.x(1) = x
        vv.x(2) = y
        Dim mm As Matrix = m.Clone()
        mm.x(1).x(0) = 0.0
        mm.x(2).x(0) = 0.0
        mm.x(3).x(0) = 0.0
        vv = mm * vv
        m.x(1).x(0) += vv.x(1)
        m.x(2).x(0) += vv.x(2)
        m.x(3).x(0) += vv.x(3)
    End Sub

End Class
