﻿'Programed by NAS6


'惑星
Public Class Planet
    Implements IComparable
    Implements ICloneable

    Public m_pno As Integer         '惑星番号
    Public m_dat0 As DateTime       '日時
    Public m_a As Double            '軌道長半径
    Public m_e As Double            '離心率
    Public m_l0 As Double           '元期
    Public m_nperday As Double      '１日の角度
    Public m_ra As Double           '近日点
    Public m_rb As Double           '遠日点
    Public m_t As Double            '公転周期
    Public m_s As Double            '昇交点黄経
    Public m_i As Double            '軌道傾斜
    Public m_w As Double            '近日点黄経
    Public m_mv As Double           '速度倍率
    Public CNST_C As Double         '光速度

    Public m_m As Double            '惑星質量
    Public m_r As Double            '惑星半径

    Public x0 As Vector             '座標
    Public v0 As Vector             '速度



    Public Function Clone() As Object Implements ICloneable.Clone
        Dim ret As New Planet
        ret.m_pno = Me.m_pno
        ret.m_dat0 = Me.m_dat0
        ret.m_a = Me.m_a
        ret.m_e = Me.m_e
        ret.m_l0 = Me.m_l0
        ret.m_nperday = Me.m_nperday
        ret.m_ra = Me.m_ra
        ret.m_rb = Me.m_rb
        ret.m_t = Me.m_t
        ret.m_s = Me.m_s
        ret.m_i = Me.m_i
        ret.m_w = Me.m_w
        ret.CNST_C = Me.CNST_C

        ret.m_m = Me.m_m
        ret.m_r = Me.m_r

        ret.x0 = Me.x0.Clone()
        ret.v0 = Me.v0.Clone()
        Return ret
    End Function

    Public Function CompareTo(obj As Object) As Integer Implements IComparable.CompareTo
        CompareTo = 0
        Dim lh As Planet = Me
        Dim rh As Planet = obj
        If Not lh.m_pno = rh.m_pno Then
            CompareTo = CompareTo Or (1 << 0)
        End If
        If Not lh.m_dat0 = rh.m_dat0 Then
            CompareTo = CompareTo Or (1 << 1)
        End If
        If Not lh.m_a = rh.m_a Then
            CompareTo = CompareTo Or (1 << 2)
        End If
        If Not lh.m_e = rh.m_e Then
            CompareTo = CompareTo Or (1 << 3)
        End If
        If Not lh.m_l0 = rh.m_l0 Then
            CompareTo = CompareTo Or (1 << 4)
        End If
        If Not lh.m_nperday = rh.m_nperday Then
            CompareTo = CompareTo Or (1 << 5)
        End If
        If Not lh.m_ra = rh.m_ra Then
            CompareTo = CompareTo Or (1 << 6)
        End If
        If Not lh.m_rb = rh.m_rb Then
            CompareTo = CompareTo Or (1 << 7)
        End If
        If Not lh.m_t = rh.m_t Then
            CompareTo = CompareTo Or (1 << 8)
        End If
        If Not lh.m_s = rh.m_s Then
            CompareTo = CompareTo Or (1 << 9)
        End If
        If Not lh.m_i = rh.m_i Then
            CompareTo = CompareTo Or (1 << 10)
        End If
        If Not lh.m_w = rh.m_w Then
            CompareTo = CompareTo Or (1 << 11)
        End If
        If Not lh.CNST_C = rh.CNST_C Then
            CompareTo = CompareTo Or (1 << 12)
        End If
        If Not lh.m_m = rh.m_m Then
            CompareTo = CompareTo Or (1 << 13)
        End If
        If Not lh.m_r = rh.m_r Then
            CompareTo = CompareTo Or (1 << 14)
        End If
        If Not lh.x0 = rh.x0 Then
            CompareTo = CompareTo Or (1 << 15)
        End If
        If Not lh.v0 = rh.v0 Then
            CompareTo = CompareTo Or (1 << 16)
        End If
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        Dim ret As Integer = CompareTo(obj)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Shared Operator =(ByVal lh As Planet, ByVal rh As Planet) As Boolean
        Dim ret As Integer = lh.CompareTo(rh)
        If ret = 0 Then
            Return True
        Else
            Return False
        End If
    End Operator

    Public Shared Operator <>(ByVal lh As Planet, ByVal rh As Planet) As Boolean
        Return (Not lh = rh)
    End Operator






    'コンストラクタ
    Public Sub New()
        x0 = New Vector(3)
        v0 = New Vector(3)
    End Sub

    'コンストラクタ
    Public Sub New(ByVal pno As Integer, ByVal nday As Double, ByVal dat0 As DateTime, ByVal aa As Double, ByVal ae As Double, ByVal al0 As Double, ByVal anperday As Double, ByVal ara As Double, ByVal arb As Double, ByVal at As Double, ByVal aas As Double, ByVal ai As Double, ByVal aw As Double, ByVal am As Double, ByVal ar As Double, ByVal amv As Double, ByVal ac As Double)
        m_pno = pno
        m_dat0 = dat0
        m_a = aa
        m_e = ae
        m_l0 = al0
        m_nperday = anperday
        m_ra = ara
        m_rb = arb
        m_t = at
        m_s = aas
        m_i = ai
        m_w = aw
        m_m = am
        m_r = ar
        m_mv = amv
        CNST_C = ac

        Dim au As Double = 149597870700.0
        Dim dr As Double = 0.017453292519943
        Dim ve As Double = 29780.0

        Dim xx As Vector = New Vector(2)
        Dim f As Double = kepler(nday, xx)
        x0 = New Vector(3)
        x0.x(0) = xx.x(0)
        x0.x(1) = xx.x(1)
        x0.x(2) = 0.0


        Dim xyz2 As Vector = New Vector(3)
        v0 = New Vector(3)

        'ケプラー方程式から軌道速度を求める
        Dim xxx As Vector = New Vector(2)
        kepler(nday + (1.0 / (24.0 * 4.0)), xxx)
        Dim vv As Vector = xxx - xx
        '速度微調整
        v0.x(0) = (vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / CNST_C) * m_mv
        v0.x(1) = (vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / CNST_C) * m_mv
        v0.x(2) = 0.0

        '速度微調整
        'If pno = 1 Then '水星
        'Dim h As Double = (x0.x(0) / au - 0.30896923101164997) * (-0.00223 / (0.46326146586797912 + 0.30896923101164997)) + 4.03027
        'v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * h)) / CNST_C
        'v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * h)) / CNST_C
        'ElseIf pno = 2 Then '金星
        'v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0075)) / CNST_C
        'v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0075)) / CNST_C
        'ElseIf pno = 4 Then '火星
        'v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0025)) / CNST_C
        'v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0025)) / CNST_C
        'Else 'その他
        'v0.x(0) = vv.x(0) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / CNST_C
        'v0.x(1) = vv.x(1) / (60.0 * 60.0 * 24.0 / (24.0 * 4.0)) / CNST_C
        'End If
        'v0.x(2) = 0.0

        '面積速度一定から軌道速度を求める
        'm_t = 1.0 / (m_nperday * dr * 365.2425 / (2.0 * Math.PI))
        'Dim vst As Double = ((1.0 / 2.0) * (Math.Sqrt(m_ra * m_rb)) * (m_ra + m_rb)) / m_t
        'Dim vr As Double = (vst / (x0.Abs() / au)) * ve / CNST_C
        'v0.x(0) = fabs(vr * Math.Sin(f))
        'v0.x(1) = fabs(vr * Math.Cos(f))
        'sgnv(x0.x(0), x0.x(1), v0.x(0), v0.x(1))

        Dim xyz As Vector = New Vector(3)
        ecliptic(x0.x(0), x0.x(1), xyz)
        If Double.IsNaN(xyz.x(0)) Or Double.IsNaN(xyz.x(1)) Or Double.IsNaN(xyz.x(2)) Then
            x0.x(0) = 0.0
            x0.x(1) = 0.0
            x0.x(2) = 0.0
        Else
            x0.x(0) = xyz.x(0)
            x0.x(1) = xyz.x(1)
            x0.x(2) = xyz.x(2)
        End If


        ecliptic(v0.x(0), v0.x(1), xyz2)
        If Double.IsNaN(xyz2.x(0)) Or Double.IsNaN(xyz2.x(1)) Or Double.IsNaN(xyz2.x(2)) Then
            v0.x(0) = 0.0
            v0.x(1) = 0.0
            v0.x(2) = 0.0
        Else
            v0.x(0) = xyz2.x(0)
            v0.x(1) = xyz2.x(1)
            v0.x(2) = xyz2.x(2)
        End If

    End Sub

    'ケプラー方程式
    Public Function kepler(ByVal nday As Double, ByRef xx As Vector) As Double
        Dim au As Double = 149597870700.0
        Dim dr As Double = 0.017453292519943
        Dim ve As Double = 29780.0

        xx = xx.ZeroVec()

        If m_pno = 0 Then
            Return 0.0
        End If

        If nday < 0.0 Then '1996年以前
            m_l0 = m_l0 + 360.0 * 1000.0
            If m_nperday * nday + m_l0 < 0.0 Then
                'MessageBox.Show("too past day!", "error")
                Return 0.0
            End If
        End If

        Dim m As Double
        Dim u As Double
        Dim du As Double
        Dim x As Double
        Dim y As Double

        'm: 平均近点角(mean anomaly)
        'u: 離心近点角(eccentric anomaly)
        'e: 離心率
        'a: 軌道長半径
        'n: 平均運動

        m = m_nperday * nday + m_l0

        m = m * dr

        Dim e2 As Double = m_e * m_e
        Dim e3 As Double = m_e * m_e * m_e
        Dim e4 As Double = m_e * m_e * m_e * m_e
        Dim e5 As Double = m_e * m_e * m_e * m_e * m_e
        Dim e6 As Double = m_e * m_e * m_e * m_e * m_e * m_e
        Dim e7 As Double = m_e * m_e * m_e * m_e * m_e * m_e * m_e

        '近似式 e = 0.5 くらいまで。彗星のように e = 1.0 に近いと崩れる。
        u = m + (m_e - 1.0 / 8.0 * e3 + 1.0 / 192.0 * e5 - 1.0 / 9216.0 * e7) * Math.Sin(m) _
              + (1.0 / 2.0 * e2 - 1.0 / 6.0 * e4 + 1.0 / 48.0 * e6) * Math.Sin(2.0 * m) _
              + (3.0 / 8.0 * e3 - 27.0 / 128.0 * e5 + 243.0 / 5120.0 * e7) * Math.Sin(3.0 * m) _
              + (1.0 / 3.0 * e4 - 4.0 / 15.0 * e6) * Math.Sin(4.0 * m) _
              + (125.0 / 384.0 * e5 - 3125.0 / 9216.0 * e7) * Math.Sin(5.0 * m) _
              + 27.0 / 80.0 * e6 * Math.Sin(6.0 * m) _
              + 16807.0 / 46080.0 * e7 * Math.Sin(7.0 * m)

        '上の近似式で得られた値を元に以下の関数を繰り返して誤差が小さくなるまで繰り返す
        '天体の位置計算 増補版 p147
        Dim lp As Integer = 0
        While True
            du = (m - u + m_e * Math.Sin(u)) / (1.0 - m_e * Math.Cos(u))
            u = u + du
            If Math.Abs(du) < 0.0000001 Then
                Exit While
            End If
            lp = lp + 1
        End While

        Dim ree As Double = Math.Sqrt(1.0 - e2)

        Dim tanf As Double = ree * Math.Sin(u) / (Math.Cos(u) - m_e)
        Dim f As Double = Math.Atan(tanf)
        If Math.Cos(u) - m_e < 0.0 Then
            f = f + Math.PI
        End If
        Dim fd As Double = f / dr
        'Dim r0 As Double = m_a * (1.0 - m_e * Math.Cos(u))

        'x = m_a * (Math.Cos(u) - m_e)
        'y = m_a * ree * Math.Sin(u)
        Dim r0 As Double = m_a * (1.0 - e2) / (1.0 + m_e * Math.Cos(f))

        x = r0 * Math.Cos(f)
        y = r0 * Math.Sin(f)

        xx = New Vector(2)
        xx.x(0) = x * au
        xx.x(1) = y * au

        Return f
    End Function

    'xy系を日心黄道直交座標系に変換
    Public Sub ecliptic(ByVal x As Double, ByVal y As Double, ByRef xyz As Vector)
        If Not xyz.x.Length = 3 Then
            Return
        End If
        Dim dr As Double = 0.017453292519943
        Dim ss As Double = m_s * dr
        Dim ii As Double = m_i * dr
        Dim ww As Double = m_w * dr
        's: 昇交点黄経 Ω
        'i: 軌道傾斜角 i 
        'w: 近日点引数 ω

        Dim vec As Vector = New Vector(3)
        vec.x(0) = x * (Math.Cos(ss) * Math.Cos(ww) - Math.Sin(ss) * Math.Cos(ii) * Math.Sin(ww)) - y * (Math.Cos(ss) * Math.Sin(ww) + Math.Sin(ss) * Math.Cos(ii) * Math.Cos(ww))
        vec.x(1) = x * (Math.Sin(ss) * Math.Cos(ww) + Math.Cos(ss) * Math.Cos(ii) * Math.Sin(ww)) - y * (Math.Sin(ss) * Math.Sin(ww) - Math.Cos(ss) * Math.Cos(ii) * Math.Cos(ww))
        vec.x(2) = x * Math.Sin(ii) * Math.Sin(ww) + y * Math.Sin(ii) * Math.Cos(ww)

        'vec.x(0) = x
        'vec.x(1) = y
        'vec.x(2) = 0.0


        'ベクトル回転
        'vec = vec.RotAxis(vec.UnitVec(2), ss).RotAxis(vec.UnitVec(0), ii).RotAxis(vec.UnitVec(2), ww)


        'vec.x(0) = x
        'vec.x(1) = y
        'vec.x(2) = 0.0

        '行列回転
        'Dim mat As Matrix = New Matrix(3)
        'mat = mat.UnitMat().RotAxisMat(vec.UnitVec(2), -ss).RotAxisMat(vec.UnitVec(0), -ii).RotAxisMat(vec.UnitVec(2), -ww)
        'vec = mat * vec




        xyz.x(0) = vec.x(1)
        xyz.x(1) = vec.x(0)
        xyz.x(2) = vec.x(2)
    End Sub

    'double絶対値
    Public Function fabs(ByVal x As Double) As Double
        fabs = x
        If fabs < 0.0 Then
            fabs = -fabs
        End If
    End Function

    '速度符号設定
    Public Sub sgnv(ByRef x As Double, ByRef y As Double, ByRef vx As Double, ByRef vy As Double)
        If x < 0.0 Then
            If y < 0.0 Then
                vy = -vy
            Else
                vx = -vx
                vy = -vy
            End If
        Else
            If y < 0.0 Then
            Else
                vx = -vx
            End If
        End If
    End Sub

End Class
